using GTA;
using GTA.Math;
using System;
using GTA.Native;
using System.IO;
using System.Windows.Forms;

public class StuntPlaneSmoke : Script
{
    bool smokeOn = false;
    Ped player;
    Vehicle veh;
    int smokeType = 1;  //set the smoke type 1-4

    public StuntPlaneSmoke()
    {
        Tick += OnTick;
        KeyDown += OnKeyDown;
    }

    private void OnTick(object sender, EventArgs e)
    {
        float size = 0.3f;  //set how big the smoke is

        if (smokeOn == true)
        {
            if (Function.Call<bool>(Hash.HAS_NAMED_PTFX_ASSET_LOADED, "scr_carsteal4"))
            {
                Function.Call(Hash._SET_PTFX_ASSET_NEXT_CALL, "scr_carsteal4");
                if (smokeType == 1)
                    Function.Call<int>(Hash.START_PARTICLE_FX_NON_LOOPED_ON_ENTITY, "scr_carsteal4_wheel_burnout", veh, -0.15f, -3.4f, 0.2f, 0, 0, 0, size, 0, 1, 0);
                if (smokeType == 2)
                    Function.Call<int>(Hash.START_PARTICLE_FX_NON_LOOPED_ON_ENTITY, "scr_carsteal4_wheel_burnout", veh, -0.15f, -5.0f, 0.3f, 0, 0, 0, size, 0, 1, 0);
                if (smokeType == 3)
                    Function.Call<int>(Hash.START_PARTICLE_FX_NON_LOOPED_ON_ENTITY, "scr_carsteal4_wheel_burnout", veh, -0.15f, 1.0f, -0.3f, 0, 0, 0, size, 0, 1, 0);
                if (smokeType == 4)
                    Function.Call<int>(Hash.START_PARTICLE_FX_NON_LOOPED_ON_ENTITY, "scr_carsteal4_wheel_burnout", veh, -4.0f, -0.5f, 0.3f, 0, 0, 0, size - 0.2, 0, 1, 0);
                Function.Call(Hash.SET_PARTICLE_FX_NON_LOOPED_COLOUR, 200.0f, 0.0f, 0.0f);  //Edit these values to change color of the smoke.  They are RGB values. 0.0f is the minimum, 255.0f is the maximum
            }
            else
            {
                Function.Call(Hash.REQUEST_NAMED_PTFX_ASSET, "scr_carsteal4");
            }

            if (Function.Call<bool>(Hash.HAS_NAMED_PTFX_ASSET_LOADED, "scr_carsteal4"))
            {
                Function.Call(Hash._SET_PTFX_ASSET_NEXT_CALL, "scr_carsteal4");
                if (smokeType == 4)
                    Function.Call<int>(Hash.START_PARTICLE_FX_NON_LOOPED_ON_ENTITY, "scr_carsteal4_wheel_burnout", veh, 4.0f, -0.5f, 0.3f, 0, 0, 0, size - 0.2, 0, 1, 0);
                Function.Call(Hash.SET_PARTICLE_FX_NON_LOOPED_COLOUR, 200.0f, 0.0f, 0.0f);  //Edit these values to change color of the smoke.  They are RGB values. 0.0f is the minimum, 255.0f is the maximum
            }
            else
            {
                Function.Call(Hash.REQUEST_NAMED_PTFX_ASSET, "scr_carsteal4");
            }
        }
    }
    void OnKeyDown(object sender, KeyEventArgs e)
    {
        player = Game.Player.Character;

        if (player.IsInVehicle())
        {
            veh = player.CurrentVehicle;

            if (veh.Model.Equals("stunt"))
            {
                switch (e.KeyCode)
                {
                    case Keys.X: //Edit the key that you have to press here
                        smokeOn = !smokeOn;
                        break;
                }
            }
            if (!veh.IsDriveable)
            {
                smokeOn = false;
            }
        }
        if (!player.IsInVehicle())
        {
            smokeOn = false;
        }
    }
}